diff -r 3f1e7d35d0ab -r 821e8eadeaff src/protocol.c
--- a/src/protocol.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/protocol.c	Sun Oct 27 22:49:29 2013 -0700
@@ -937,19 +1120,19 @@
 	case PTP_LISTENING:
 		DBGV("Handfollowup : disregard\n");
 		return;
-		
-	case PTP_UNCALIBRATED:	
+
+	case PTP_UNCALIBRATED:
 	case PTP_SLAVE:
-		isFromCurrentParent = 
+		isFromCurrentParent =
 			!memcmp(ptpClock->parentPortIdentity.clockIdentity,
 				header->sourcePortIdentity.clockIdentity,
-				CLOCK_IDENTITY_LENGTH) && 
-			(ptpClock->parentPortIdentity.portNumber == 
+				CLOCK_IDENTITY_LENGTH) &&
+			(ptpClock->parentPortIdentity.portNumber ==
 			 header->sourcePortIdentity.portNumber);
-	 	
+
 		if (isFromCurrentParent) {
 			if (ptpClock->waitingForFollow)	{
-				if ((ptpClock->recvSyncSequenceId == 
+				if ((ptpClock->recvSyncSequenceId ==
 				     header->sequenceId)) {
 					msgUnpackFollowUp(ptpClock->msgIbuf,
 							  &ptpClock->msgTmp.follow);
@@ -979,6 +1162,7 @@
 				     "message \n");
 		} else
 			DBG2("Ignored, Follow up message is not from current parent \n");
+	break;
 
 	case PTP_MASTER:
 	case PTP_PASSIVE:
@@ -994,13 +1178,13 @@
 
 
 void
-handleDelayReq(MsgHeader *header, Octet *msgIbuf, ssize_t length, 
+handleDelayReq(MsgHeader *header, Octet *msgIbuf, ssize_t length,
 	       TimeInternal *time, Boolean isFromSelf,
 	       RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
 	if (ptpClock->delayMechanism == E2E) {
 		DBGV("delayReq message received : \n");
-		
+
 		if (length < DELAY_REQ_LENGTH) {
 			ERROR("short DelayReq message\n");
 			toState(PTP_FAULTY, rtOpts, ptpClock);
@@ -1018,7 +1202,7 @@
 			return;
 
 		case PTP_SLAVE:
-			if (isFromSelf)	{
+			if (isFromSelf) {
 				DBG("==> Handle DelayReq (%d)\n",
 					 header->sequenceId);
 				
@@ -1062,14 +1246,14 @@
 			// remember IP address of this client for -U option
 			ptpClock->LastSlaveAddr = ptpClock->netPath.lastRecvAddr;
 #endif
-					
+			
 			issueDelayResp(time,&ptpClock->delayReqHeader,
-				       rtOpts,ptpClock);
+					rtOpts,ptpClock);
 			break;
 
 		default:
 			DBG("do unrecognized state2\n");
-			break;
+      break;
 		}
 	} else /* (Peer to Peer mode) */
 		ERROR("Delay messages are ignored in Peer to Peer mode\n");
@@ -1108,16 +1292,16 @@
 			if ((memcmp(ptpClock->parentPortIdentity.clockIdentity,
 				    header->sourcePortIdentity.clockIdentity,
 				    CLOCK_IDENTITY_LENGTH) == 0 ) &&
-			    (ptpClock->parentPortIdentity.portNumber == 
+			    (ptpClock->parentPortIdentity.portNumber ==
 			     header->sourcePortIdentity.portNumber))
 				isFromCurrentParent = TRUE;
-			
+
 			if ((memcmp(ptpClock->portIdentity.clockIdentity,
 				    ptpClock->msgTmp.resp.requestingPortIdentity.clockIdentity,
 				    CLOCK_IDENTITY_LENGTH) == 0) &&
-			    ((ptpClock->sentDelayReqSequenceId - 1)== 
+			    ((UInteger16)(ptpClock->sentDelayReqSequenceId - 1)==
 			     header->sequenceId) &&
-			    (ptpClock->portIdentity.portNumber == 
+			    (ptpClock->portIdentity.portNumber ==
 			     ptpClock->msgTmp.resp.requestingPortIdentity.portNumber)
 			    && isFromCurrentParent) {
 				DBG("==> Handle DelayResp (%d)\n",
@@ -1131,15 +1315,15 @@
 
 				toInternalTime(&requestReceiptTimestamp,
 					       &ptpClock->msgTmp.resp.receiveTimestamp);
-				ptpClock->delay_req_receive_time.seconds = 
+				ptpClock->delay_req_receive_time.seconds =
 					requestReceiptTimestamp.seconds;
-				ptpClock->delay_req_receive_time.nanoseconds = 
+				ptpClock->delay_req_receive_time.nanoseconds =
 					requestReceiptTimestamp.nanoseconds;
 
 				integer64_to_internalTime(
 					header->correctionfield,
 					&correctionField);
-				
+
 				/*
 					send_time = delay_req_send_time (received as CMSG in handleEvent)
 					recv_time = requestReceiptTimestamp (received inside delayResp)
@@ -1150,7 +1334,7 @@
 
 				if (ptpClock->waiting_for_first_delayresp) {
 					ptpClock->waiting_for_first_delayresp = FALSE;
-					NOTICE("  received first DelayResp from Master\n");
+					NOTICE(" received first DelayResp from Master\n");
 				}
 
 				if (rtOpts->ignore_delayreq_interval_master == 0) {
@@ -1160,18 +1344,19 @@
 
 					/* Accept new DelayReq value from the Master */
 					if (ptpClock->logMinDelayReqInterval != header->logMessageInterval) {
-						NOTICE("  received new DelayReq frequency %d from Master (was: %d)\n",
+						NOTICE(" received new DelayReq frequency %d from Master (was: %d)\n",
 							 header->logMessageInterval, ptpClock->logMinDelayReqInterval );
 					}
 
 					// collect new value indicated from the Master
 					ptpClock->logMinDelayReqInterval = header->logMessageInterval;
-					
+					ptpClock->minDelayReqInterval = pow(2, header->logMessageInterval);
+
 					/* FIXME: the actual rearming of this timer with the new value only happens later in doState()/issueDelayReq() */
 				} else {
-					if (ptpClock->logMinDelayReqInterval != rtOpts->subsequent_delayreq) {
+					if (ptpClock->minDelayReqInterval != rtOpts->subsequent_delayreq) {
 						NOTICE("  received new DelayReq frequency %d from command line (was: %d)\n",
-							rtOpts->subsequent_delayreq, ptpClock->logMinDelayReqInterval);
+							rtOpts->subsequent_delayreq, ptpClock->minDelayReqInterval);
 					}
 					ptpClock->logMinDelayReqInterval = rtOpts->subsequent_delayreq;
 				}
@@ -1187,9 +1372,9 @@
 }
 
 
-void 
-handlePDelayReq(MsgHeader *header, Octet *msgIbuf, ssize_t length, 
-		TimeInternal *time, Boolean isFromSelf, 
+void
+handlePDelayReq(MsgHeader *header, Octet *msgIbuf, ssize_t length,
+		TimeInternal *time, Boolean isFromSelf,
 		RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
 	if (ptpClock->delayMechanism == P2P) {
@@ -1201,7 +1386,7 @@
 			return;
 		}
 
-		switch (ptpClock->portState ) {
+		switch(ptpClock->portState ) {
 		case PTP_INITIALIZING:
 		case PTP_FAULTY:
 		case PTP_DISABLED:
@@ -1222,7 +1407,7 @@
 					time->seconds;
 				ptpClock->pdelay_req_send_time.nanoseconds = 
 					time->nanoseconds;
-			
+
 				/*Add latency*/
 				addTime(&ptpClock->pdelay_req_send_time,
 					&ptpClock->pdelay_req_send_time,
@@ -1230,33 +1415,33 @@
 				break;
 			} else {
 				msgUnpackHeader(ptpClock->msgIbuf,
-						&ptpClock->PdelayReqHeader);
-				issuePDelayResp(time, header, rtOpts, 
-						ptpClock);	
+					&ptpClock->PdelayReqHeader);
+				issuePDelayResp(time, header, rtOpts,
+					ptpClock);
 				break;
 			}
-		default:
-			DBG("do unrecognized state3\n");
-			break;
-		}
-	} else /* (End to End mode..) */
+    default:
+      DBG("do unrecognized state3\n");
+      break;
+    }
+  } else /* (End to End mode..) */
 		ERROR("Peer Delay messages are disregarded in End to End "
 		      "mode \n");
 }
 
 void
 handlePDelayResp(MsgHeader *header, Octet *msgIbuf, TimeInternal *time,
-		 ssize_t length, Boolean isFromSelf, 
+		 ssize_t length, Boolean isFromSelf,
 		 RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
 	if (ptpClock->delayMechanism == P2P) {
 		/* Boolean isFromCurrentParent = FALSE; NOTE: This is never used in this function */
 		TimeInternal requestReceiptTimestamp;
 		TimeInternal correctionField;
-	
+
 		DBGV("PdelayResp message received : \n");
 
-		if (length < PDELAY_RESP_LENGTH) {
+		if (length < PDELAY_RESP_LENGTH)	{
 			ERROR("short PDelayResp message\n");
 			toState(PTP_FAULTY, rtOpts, ptpClock);
 			return;
@@ -1276,25 +1461,29 @@
 			if (ptpClock->twoStepFlag && isFromSelf) {
 				addTime(time,time,&rtOpts->outboundLatency);
 				issuePDelayRespFollowUp(time,
-							&ptpClock->PdelayReqHeader,
-							rtOpts,ptpClock);
+						&ptpClock->PdelayReqHeader,
+						rtOpts,ptpClock);
 				break;
 			}
 			msgUnpackPDelayResp(ptpClock->msgIbuf,
 					    &ptpClock->msgTmp.presp);
-		
+
 #if 0  /* NOTE: This is never used in this function. Should it? */
 			isFromCurrentParent = !memcmp(ptpClock->parentPortIdentity.clockIdentity,
-						      header->sourcePortIdentity.clockIdentity,CLOCK_IDENTITY_LENGTH) && 
-				(ptpClock->parentPortIdentity.portNumber == 
+						      header->sourcePortIdentity.clockIdentity,CLOCK_IDENTITY_LENGTH) &&
+				(ptpClock->parentPortIdentity.portNumber ==
 				 header->sourcePortIdentity.portNumber);
-#endif	
-			if (!((ptpClock->sentPDelayReqSequenceId == 
-			       header->sequenceId) && 
+#endif  
+      /* TODO Not convinced that we will detect scenario where peer delay was transmitted but
+       * the retrieval of the timestamp failed. In theory, we should reject the response packet
+       * here because the sequence number doesn't match
+       */
+			if (!((ptpClock->sentPDelayReqSequenceId ==
+			       header->sequenceId) &&
 			      (!memcmp(ptpClock->portIdentity.clockIdentity,ptpClock->msgTmp.presp.requestingPortIdentity.clockIdentity,CLOCK_IDENTITY_LENGTH))
 				 && ( ptpClock->portIdentity.portNumber == ptpClock->msgTmp.presp.requestingPortIdentity.portNumber)))	{
 
-				/* Two Step Clock */
+                                /* Two Step Clock */
 				if ((header->flagField[0] & PTP_TWO_STEP) == PTP_TWO_STEP) {
 					/*Store t4 (Fig 35)*/
 					ptpClock->pdelay_resp_receive_time.seconds = time->seconds;
@@ -1304,7 +1493,7 @@
 						       &ptpClock->msgTmp.presp.requestReceiptTimestamp);
 					ptpClock->pdelay_req_receive_time.seconds = requestReceiptTimestamp.seconds;
 					ptpClock->pdelay_req_receive_time.nanoseconds = requestReceiptTimestamp.nanoseconds;
-					
+
 					integer64_to_internalTime(header->correctionfield,&correctionField);
 					ptpClock->lastPdelayRespCorrectionField.seconds = correctionField.seconds;
 					ptpClock->lastPdelayRespCorrectionField.nanoseconds = correctionField.nanoseconds;
@@ -1314,7 +1503,7 @@
 					/*Store t4 (Fig 35)*/
 					ptpClock->pdelay_resp_receive_time.seconds = time->seconds;
 					ptpClock->pdelay_resp_receive_time.nanoseconds = time->nanoseconds;
-					
+
 					integer64_to_internalTime(header->correctionfield,&correctionField);
 					updatePeerDelay (&ptpClock->owd_filt,rtOpts,ptpClock,&correctionField,FALSE);
 					break;
@@ -1337,23 +1526,23 @@
 	}
 }
 
-void 
-handlePDelayRespFollowUp(MsgHeader *header, Octet *msgIbuf, ssize_t length, 
-			 Boolean isFromSelf, RunTimeOpts *rtOpts, 
+void
+handlePDelayRespFollowUp(MsgHeader *header, Octet *msgIbuf, ssize_t length,
+			 Boolean isFromSelf, RunTimeOpts *rtOpts,
 			 PtpClock *ptpClock){
 
 	if (ptpClock->delayMechanism == P2P) {
 		TimeInternal responseOriginTimestamp;
 		TimeInternal correctionField;
-	
+
 		DBGV("PdelayRespfollowup message received : \n");
-	
+
 		if(length < PDELAY_RESP_FOLLOW_UP_LENGTH) {
 			ERROR("short PDelayRespfollowup message\n");
 			toState(PTP_FAULTY, rtOpts, ptpClock);
 			return;
-		}	
-	
+		}
+
 		switch(ptpClock->portState) {
 		case PTP_INITIALIZING:
 		case PTP_FAULTY:
@@ -1361,29 +1550,29 @@
 		case PTP_UNCALIBRATED:
 			DBGV("HandlePdelayResp : disregard\n");
 			return;
-		
+
 		case PTP_SLAVE:
 		case PTP_MASTER:
 			if ((header->sequenceId == 
-			    ptpClock->sentPDelayReqSequenceId-1) && (header->sequenceId == ptpClock->recvPDelayRespSequenceId)) {
+			      (UInteger16)(ptpClock->sentPDelayReqSequenceId-1)) && (header->sequenceId == ptpClock->recvPDelayRespSequenceId)) {
 				msgUnpackPDelayRespFollowUp(
-					ptpClock->msgIbuf,
-					&ptpClock->msgTmp.prespfollow);
+						ptpClock->msgIbuf,
+						&ptpClock->msgTmp.prespfollow);
 				toInternalTime(
-					&responseOriginTimestamp,
-					&ptpClock->msgTmp.prespfollow.responseOriginTimestamp);
-				ptpClock->pdelay_resp_send_time.seconds = 
-					responseOriginTimestamp.seconds;
-				ptpClock->pdelay_resp_send_time.nanoseconds = 
-					responseOriginTimestamp.nanoseconds;
+						&responseOriginTimestamp,
+						&ptpClock->msgTmp.prespfollow.responseOriginTimestamp);
+				 ptpClock->pdelay_resp_send_time.seconds = 
+					 responseOriginTimestamp.seconds;
+				 ptpClock->pdelay_resp_send_time.nanoseconds = 
+					 responseOriginTimestamp.nanoseconds;
 				integer64_to_internalTime(
-					ptpClock->msgTmpHeader.correctionfield,
-					&correctionField);
+						ptpClock->msgTmpHeader.correctionfield,
+						&correctionField);
 				addTime(&correctionField,&correctionField,
-					&ptpClock->lastPdelayRespCorrectionField);
+						&ptpClock->lastPdelayRespCorrectionField);
 				updatePeerDelay (&ptpClock->owd_filt,
-						 rtOpts, ptpClock,
-						 &correctionField,TRUE);
+						rtOpts, ptpClock,
+						&correctionField,TRUE);
 				break;
 			}
 		default:
@@ -1395,26 +1584,26 @@
 	}
 }
 
-void 
-handleManagement(MsgHeader *header, Octet *msgIbuf, ssize_t length, 
+void
+handleManagement(MsgHeader *header, Octet *msgIbuf, ssize_t length,
 		 Boolean isFromSelf, RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {}
 
-void 
-handleSignaling(MsgHeader *header, Octet *msgIbuf, ssize_t length, 
-		     Boolean isFromSelf, RunTimeOpts *rtOpts, 
+void
+handleSignaling(MsgHeader *header, Octet *msgIbuf, ssize_t length,
+		     Boolean isFromSelf, RunTimeOpts *rtOpts,
 		     PtpClock *ptpClock)
 {}
 
 
 /*Pack and send on general multicast ip adress an Announce message*/
-void 
+void
 issueAnnounce(RunTimeOpts *rtOpts,PtpClock *ptpClock)
 {
 	msgPackAnnounce(ptpClock->msgObuf,ptpClock);
 
-	if (!netSendGeneral(ptpClock->msgObuf,ANNOUNCE_LENGTH,
-			    &ptpClock->netPath, 0)) {
+	if (netSendGeneral(ptpClock->msgObuf,ANNOUNCE_LENGTH,
+			    &ptpClock->netPath, 0) != 0) {
 		toState(PTP_FAULTY,rtOpts,ptpClock);
 		DBGV("Announce message can't be sent -> FAULTY state \n");
 	} else {
@@ -1429,20 +1618,30 @@
 void
 issueSync(RunTimeOpts *rtOpts,PtpClock *ptpClock)
 {
-	Timestamp originTimestamp;
-	TimeInternal internalTime;
-	getTime(&internalTime);
-	fromInternalTime(&internalTime,&originTimestamp);
+  Timestamp originTimestamp;
+  TimeInternal internalTime;
+  int rc;
+  
+  getTime(&internalTime, rtOpts->time_mode, ptpClock); 
+  fromInternalTime(&internalTime,&originTimestamp);
 
-	msgPackSync(ptpClock->msgObuf,&originTimestamp,ptpClock);
+  msgPackSync(ptpClock->msgObuf,&originTimestamp,ptpClock);
 
-	if (!netSendEvent(ptpClock->msgObuf,SYNC_LENGTH,&ptpClock->netPath, 0)) {
-		toState(PTP_FAULTY,rtOpts,ptpClock);
-		DBGV("Sync message can't be sent -> FAULTY state \n");
-	} else {
-		DBGV("Sync MSG sent ! \n");
-		ptpClock->sentSyncSequenceId++;
-	}
+  rc = netSendEvent(ptpClock->msgObuf,SYNC_LENGTH,ptpClock,rtOpts, 0);
+  if (rc != 0) {
+    /* If we failed because we didn't retrieve the transmit timestamp this is 
+     * most likely because we've lost the network connection. PTPD will recover
+     * if the network connection is reestablished. In this case don't go into the
+     * faulty state as this does a complete re-initialisation.
+     */
+    if (rc != ENOTIMESTAMP) {
+      toState(PTP_FAULTY,rtOpts,ptpClock);
+      DBGV("Sync message can't be sent -> FAULTY state \n");
+    }
+  } else {
+    DBGV("Sync MSG sent ! \n");
+    ptpClock->sentSyncSequenceId++;
+  }
 }
 
 
@@ -1452,11 +1651,11 @@
 {
 	Timestamp preciseOriginTimestamp;
 	fromInternalTime(time,&preciseOriginTimestamp);
-	
+
 	msgPackFollowUp(ptpClock->msgObuf,&preciseOriginTimestamp,ptpClock);
-	
-	if (!netSendGeneral(ptpClock->msgObuf,FOLLOW_UP_LENGTH,
-			    &ptpClock->netPath, 0)) {
+
+	if (netSendGeneral(ptpClock->msgObuf,FOLLOW_UP_LENGTH,
+				&ptpClock->netPath, 0) != 0) {
 		toState(PTP_FAULTY,rtOpts,ptpClock);
 		DBGV("FollowUp message can't be sent -> FAULTY state \n");
 	} else {
@@ -1471,11 +1670,12 @@
 {
 	Timestamp originTimestamp;
 	TimeInternal internalTime;
+	int rc;
 
 	DBG("==> Issue DelayReq (%d)\n", ptpClock->sentDelayReqSequenceId );
 
 	/* call GTOD. This time is later replaced on handle_delayreq, to get the actual send timestamp from the OS */
-	getTime(&internalTime);
+	getTime(&internalTime, rtOpts->time_mode, ptpClock);
 	fromInternalTime(&internalTime,&originTimestamp);
 
 	// uses current sentDelayReqSequenceId
@@ -1488,61 +1688,89 @@
 	}
 #endif
 
-	if (!netSendEvent(ptpClock->msgObuf,DELAY_REQ_LENGTH,
-			  &ptpClock->netPath, dst)) {
-		toState(PTP_FAULTY,rtOpts,ptpClock);
-		DBGV("delayReq message can't be sent -> FAULTY state \n");
-	} else {
-		DBGV("DelayReq MSG sent ! \n");
-		ptpClock->sentDelayReqSequenceId++;
+	rc = netSendEvent(ptpClock->msgObuf, DELAY_REQ_LENGTH,
+			ptpClock,rtOpts, dst);
+  if (rc != 0) {
+    /* If we failed because we didn't retrieve the transmit timestamp this is 
+     * most likely because we've lost the network connection. PTPD will recover
+     * if the network connection is reestablished. In this case don't go into the
+     * faulty state as this does a complete re-initialisation.
+     */
+    if (rc != ENOTIMESTAMP) {
+      toState(PTP_FAULTY,rtOpts,ptpClock);
+      DBGV("delayReq message can't be sent -> FAULTY state \n");
+    }
+  } else {
+    DBGV("DelayReq MSG sent ! \n");
+    ptpClock->sentDelayReqSequenceId++;
 
 		/* From now on, we will only accept delayreq and delayresp of (sentDelayReqSequenceId - 1) */
 
-		/* Explicitelly re-arm timer for sending the next delayReq */
-		timerStart_random(DELAYREQ_INTERVAL_TIMER,
-		   pow(2,ptpClock->logMinDelayReqInterval),
-		   ptpClock->itimer);
-	}
+    /* Explicitelly re-arm timer for sending the next delayReq */
+    timerStart_random(DELAYREQ_INTERVAL_TIMER,
+		    ptpClock->minDelayReqInterval,
+                       ptpClock->itimer);
+  }
 }
 
 /*Pack and send on event multicast ip adress a PDelayReq message*/
 void
 issuePDelayReq(RunTimeOpts *rtOpts,PtpClock *ptpClock)
 {
-	Timestamp originTimestamp;
-	TimeInternal internalTime;
-	getTime(&internalTime);
-	fromInternalTime(&internalTime,&originTimestamp);
-	
-	msgPackPDelayReq(ptpClock->msgObuf,&originTimestamp,ptpClock);
+  Timestamp originTimestamp;
+  TimeInternal internalTime;
+  int rc;
+  
+  getTime(&internalTime, rtOpts->time_mode, ptpClock);
+  fromInternalTime(&internalTime,&originTimestamp);
 
-	if (!netSendPeerEvent(ptpClock->msgObuf,PDELAY_REQ_LENGTH,
-			      &ptpClock->netPath)) {
-		toState(PTP_FAULTY,rtOpts,ptpClock);
-		DBGV("PdelayReq message can't be sent -> FAULTY state \n");
-	} else {
-		DBGV("PDelayReq MSG sent ! \n");
-		ptpClock->sentPDelayReqSequenceId++;
-	}
+  msgPackPDelayReq(ptpClock->msgObuf,&originTimestamp,ptpClock);
+
+  rc = netSendPeerEvent(ptpClock->msgObuf,PDELAY_REQ_LENGTH,
+		  ptpClock, rtOpts);
+  if (rc != 0) {
+    /* If we failed because we didn't retrieve the transmit timestamp this is 
+     * most likely because we've lost the network connection. PTPD will recover
+     * if the network connection is reestablished. In this case don't go into the
+     * faulty state as this does a complete re-initialisation.
+     */
+    if (rc != ENOTIMESTAMP) {
+      toState(PTP_FAULTY,rtOpts,ptpClock);
+      DBGV("PdelayReq message can't be sent -> FAULTY state \n");
+    }
+  } else {
+    DBGV("PDelayReq MSG sent ! \n");
+    ptpClock->sentPDelayReqSequenceId++;
+  }
 }
 
 /*Pack and send on event multicast ip adress a PDelayResp message*/
 void
 issuePDelayResp(TimeInternal *time,MsgHeader *header,RunTimeOpts *rtOpts,
-		PtpClock *ptpClock)
+                PtpClock *ptpClock)
 {
-	Timestamp requestReceiptTimestamp;
-	fromInternalTime(time,&requestReceiptTimestamp);
-	msgPackPDelayResp(ptpClock->msgObuf,header,
-			  &requestReceiptTimestamp,ptpClock);
+  Timestamp requestReceiptTimestamp;
+  fromInternalTime(time,&requestReceiptTimestamp);
+  int rc;
+  
+  msgPackPDelayResp(ptpClock->msgObuf,header,
+		  &requestReceiptTimestamp,ptpClock);
 
-	if (!netSendPeerEvent(ptpClock->msgObuf,PDELAY_RESP_LENGTH,
-			      &ptpClock->netPath)) {
-		toState(PTP_FAULTY,rtOpts,ptpClock);
-		DBGV("PdelayResp message can't be sent -> FAULTY state \n");
-	} else {
-		DBGV("PDelayResp MSG sent ! \n");
-	}
+  rc = netSendPeerEvent(ptpClock->msgObuf,PDELAY_RESP_LENGTH,
+		  ptpClock, rtOpts);
+  if (rc != 0) {
+    /* If we failed because we didn't retrieve the transmit timestamp this is 
+     * most likely because we've lost the network connection. PTPD will recover
+     * if the network connection is reestablished. In this case don't go into the
+     * faulty state as this does a complete re-initialisation.
+     */
+    if (rc != ENOTIMESTAMP) {
+      toState(PTP_FAULTY,rtOpts,ptpClock);
+      DBGV("PdelayResp message can't be sent -> FAULTY state \n");
+    }
+  } else {
+    DBGV("PDelayResp MSG sent ! \n");
+  }
 }
 
 
@@ -1562,8 +1790,8 @@
 	}
 #endif
 
-	if (!netSendGeneral(ptpClock->msgObuf,PDELAY_RESP_LENGTH,
-			    &ptpClock->netPath, dst)) {
+	if (netSendGeneral(ptpClock->msgObuf,PDELAY_RESP_LENGTH,
+				&ptpClock->netPath, dst) != 0) {
 		toState(PTP_FAULTY,rtOpts,ptpClock);
 		DBGV("delayResp message can't be sent -> FAULTY state \n");
 	} else {
@@ -1574,73 +1802,73 @@
 
 void
 issuePDelayRespFollowUp(TimeInternal *time, MsgHeader *header,
-			     RunTimeOpts *rtOpts, PtpClock *ptpClock)
+                             RunTimeOpts *rtOpts, PtpClock *ptpClock)
 {
-	Timestamp responseOriginTimestamp;
-	fromInternalTime(time,&responseOriginTimestamp);
+  Timestamp responseOriginTimestamp;
+  fromInternalTime(time,&responseOriginTimestamp);
 
-	msgPackPDelayRespFollowUp(ptpClock->msgObuf,header,
-				  &responseOriginTimestamp,ptpClock);
+  msgPackPDelayRespFollowUp(ptpClock->msgObuf,header,
+		  &responseOriginTimestamp,ptpClock);
 
-	if (!netSendPeerGeneral(ptpClock->msgObuf,
-				PDELAY_RESP_FOLLOW_UP_LENGTH,
-				&ptpClock->netPath)) {
-		toState(PTP_FAULTY,rtOpts,ptpClock);
-		DBGV("PdelayRespFollowUp message can't be sent -> FAULTY state \n");
-	} else {
-		DBGV("PDelayRespFollowUp MSG sent ! \n");
-	}
+  if (netSendPeerGeneral(ptpClock->msgObuf,
+			  PDELAY_RESP_FOLLOW_UP_LENGTH,
+			  &ptpClock->netPath) != 0) {
+    toState(PTP_FAULTY,rtOpts,ptpClock);
+    DBGV("PdelayRespFollowUp message can't be sent -> FAULTY state \n");
+  } else {
+    DBGV("PDelayRespFollowUp MSG sent ! \n");
+  }
 }
 
-void 
+void
 issueManagement(MsgHeader *header,MsgManagement *manage,RunTimeOpts *rtOpts,
 		PtpClock *ptpClock)
 {}
 
-void 
+void
 addForeign(Octet *buf,MsgHeader *header,PtpClock *ptpClock)
 {
 	int i,j;
 	Boolean found = FALSE;
 
 	j = ptpClock->foreign_record_best;
-	
+
 	/*Check if Foreign master is already known*/
 	for (i=0;i<ptpClock->number_foreign_records;i++) {
 		if (!memcmp(header->sourcePortIdentity.clockIdentity,
 			    ptpClock->foreign[j].foreignMasterPortIdentity.clockIdentity,
-			    CLOCK_IDENTITY_LENGTH) && 
-		    (header->sourcePortIdentity.portNumber == 
+			    CLOCK_IDENTITY_LENGTH) &&
+		    (header->sourcePortIdentity.portNumber ==
 		     ptpClock->foreign[j].foreignMasterPortIdentity.portNumber))
 		{
 			/*Foreign Master is already in Foreignmaster data set*/
-			ptpClock->foreign[j].foreignMasterAnnounceMessages++; 
+			ptpClock->foreign[j].foreignMasterAnnounceMessages++;
 			found = TRUE;
 			DBGV("addForeign : AnnounceMessage incremented \n");
 			msgUnpackHeader(buf,&ptpClock->foreign[j].header);
 			msgUnpackAnnounce(buf,&ptpClock->foreign[j].announce);
 			break;
 		}
-	
+
 		j = (j+1)%ptpClock->number_foreign_records;
 	}
 
 	/*New Foreign Master*/
 	if (!found) {
-		if (ptpClock->number_foreign_records < 
+		if (ptpClock->number_foreign_records <
 		    ptpClock->max_foreign_records) {
 			ptpClock->number_foreign_records++;
 		}
 		j = ptpClock->foreign_record_i;
-		
+
 		/*Copy new foreign master data set from Announce message*/
 		memcpy(ptpClock->foreign[j].foreignMasterPortIdentity.clockIdentity,
 		       header->sourcePortIdentity.clockIdentity,
 		       CLOCK_IDENTITY_LENGTH);
-		ptpClock->foreign[j].foreignMasterPortIdentity.portNumber = 
+		ptpClock->foreign[j].foreignMasterPortIdentity.portNumber =
 			header->sourcePortIdentity.portNumber;
 		ptpClock->foreign[j].foreignMasterAnnounceMessages = 0;
-		
+
 		/*
 		 * header and announce field of each Foreign Master are
 		 * usefull to run Best Master Clock Algorithm
@@ -1648,9 +1876,9 @@
 		msgUnpackHeader(buf,&ptpClock->foreign[j].header);
 		msgUnpackAnnounce(buf,&ptpClock->foreign[j].announce);
 		DBGV("New foreign Master added \n");
-		
-		ptpClock->foreign_record_i = 
-			(ptpClock->foreign_record_i+1) % 
-			ptpClock->max_foreign_records;	
+
+		ptpClock->foreign_record_i =
+			(ptpClock->foreign_record_i+1) %
+			ptpClock->max_foreign_records;
 	}
 }
diff -r 3f1e7d35d0ab -r 821e8eadeaff src/ptpd.c
--- a/src/ptpd.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/ptpd.c	Sun Oct 27 22:49:29 2013 -0700
@@ -1,4 +1,6 @@
 /*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
  * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
  *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
  * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
@@ -57,48 +59,54 @@
 int
 main(int argc, char **argv)
 {
-	PtpClock *ptpClock;
-	Integer16 ret;
+    PtpClock *ptpClock;
+    Integer16 ret;
 
-	/* initialize run-time options to default values */
-	rtOpts.announceInterval = DEFAULT_ANNOUNCE_INTERVAL;
-	rtOpts.syncInterval = DEFAULT_SYNC_INTERVAL;
-	rtOpts.clockQuality.clockAccuracy = DEFAULT_CLOCK_ACCURACY;
-	rtOpts.clockQuality.clockClass = DEFAULT_CLOCK_CLASS;
-	rtOpts.clockQuality.offsetScaledLogVariance = DEFAULT_CLOCK_VARIANCE;
-	rtOpts.priority1 = DEFAULT_PRIORITY1;
-	rtOpts.priority2 = DEFAULT_PRIORITY2;
-	rtOpts.domainNumber = DEFAULT_DOMAIN_NUMBER;
+    /* initialize run-time options to default values */
+    rtOpts.announceInterval = DEFAULT_ANNOUNCE_INTERVAL;
+    rtOpts.syncInterval = DEFAULT_SYNC_INTERVAL;
+    rtOpts.clockQuality.clockAccuracy = DEFAULT_CLOCK_ACCURACY;
+    rtOpts.clockQuality.clockClass = DEFAULT_CLOCK_CLASS;
+    rtOpts.clockQuality.offsetScaledLogVariance = DEFAULT_CLOCK_VARIANCE;
+    rtOpts.priority1 = DEFAULT_PRIORITY1;
+    rtOpts.priority2 = DEFAULT_PRIORITY2;
+    rtOpts.domainNumber = DEFAULT_DOMAIN_NUMBER;
 #ifdef PTP_EXPERIMENTAL
 	rtOpts.mcast_group_Number = 0;
 	rtOpts.do_hybrid_mode = 0;
 #endif
 	
 	// rtOpts.slaveOnly = FALSE;
-	rtOpts.currentUtcOffset = DEFAULT_UTC_OFFSET;
-	rtOpts.ifaceName[0] = '\0';
-	rtOpts.do_unicast_mode = 0;
-
-	rtOpts.noAdjust = NO_ADJUST;  // false
-	// rtOpts.displayStats = FALSE;
-	// rtOpts.csvStats = FALSE;
-	/* Deep display of all packets seen by the daemon */
-	rtOpts.displayPackets = FALSE;
-	// rtOpts.unicastAddress
-	rtOpts.ap = DEFAULT_AP;
-	rtOpts.ai = DEFAULT_AI;
-	rtOpts.s = DEFAULT_DELAY_S;
-	rtOpts.inboundLatency.nanoseconds = DEFAULT_INBOUND_LATENCY;
-	rtOpts.outboundLatency.nanoseconds = DEFAULT_OUTBOUND_LATENCY;
-	rtOpts.max_foreign_records = DEFAULT_MAX_FOREIGN_RECORDS;
-	// rtOpts.ethernet_mode = FALSE;
-	// rtOpts.offset_first_updated = FALSE;
-	// rtOpts.file[0] = 0;
-	rtOpts.logFd = -1;
-	rtOpts.recordFP = NULL;
-	rtOpts.do_log_to_file = FALSE;
-	rtOpts.do_record_quality_file = FALSE;
-	rtOpts.nonDaemon = FALSE;
+    rtOpts.currentUtcOffset = DEFAULT_UTC_OFFSET;
+    rtOpts.currentUtcOffsetValid = DEFAULT_UTC_VALID;
+    rtOpts.ifaceName[0] = '\0';
+    rtOpts.do_unicast_mode = 0;
+    rtOpts.resetClockStartupOnly = DEFAULT_RESET_CLOCK_STARTUP_ONLY;
+    rtOpts.maxReset = 0;
+    rtOpts.maxDelay.seconds = 0;
+    rtOpts.maxDelay.nanoseconds = 0;
+    rtOpts.noAdjust = NO_ADJUST;	// false
+    // rtOpts.displayStats = FALSE;
+    rtOpts.verboseStats = FALSE;
+    // rtOpts.csvStats = FALSE;
+    /* Deep display of all packets seen by the daemon */
+    rtOpts.displayPackets = FALSE;
+    // rtOpts.unicastAddress
+    rtOpts.ap = DEFAULT_AP;
+    rtOpts.ai = DEFAULT_AI;
+    rtOpts.s = DEFAULT_DELAY_S;
+    rtOpts.inboundLatency.nanoseconds = DEFAULT_INBOUND_LATENCY;
+    rtOpts.outboundLatency.nanoseconds = DEFAULT_OUTBOUND_LATENCY;
+    rtOpts.max_foreign_records = DEFAULT_MAX_FOREIGN_RECORDS;
+    rtOpts.ethernet_mode = FALSE;
+    // rtOpts.offset_first_updated = FALSE;
+    // rtOpts.file[0] = 0;
+    rtOpts.logFd = -1;
+    rtOpts.recordFP = NULL;
+    rtOpts.ignore_daemon_lock = FALSE;
+    rtOpts.do_log_to_file = FALSE;
+    rtOpts.do_record_quality_file = FALSE;
+    rtOpts.nonDaemon = FALSE;
 
 	/*
 	 * defaults for new options
@@ -112,6 +120,9 @@
 #ifdef RUNTIME_DEBUG
 	rtOpts.debug_level = LOG_INFO;			/* by default debug messages as disabled, but INFO messages and below are printed */
 #endif
+	rtOpts.time_mode = DEFAULT_SLAVE_TIME_MODE;
+	rtOpts.master_slave_mode = PTP_MODE_NULL;
+	rtOpts.system_time_update_interval = DEFAULT_SYSTEM_TIME_UPDATE_INTERVAL;
 
 	rtOpts.ttl = 1;
 	rtOpts.delayMechanism   = DEFAULT_DELAY_MECHANISM;
@@ -121,20 +132,20 @@
 	rtOpts.initial_delayreq = DEFAULT_DELAYREQ_INTERVAL;
 	rtOpts.subsequent_delayreq = DEFAULT_DELAYREQ_INTERVAL;      // this will be updated if -g is given
 
-	/* Initialize run time options with command line arguments */
-	if (!(ptpClock = ptpdStartup(argc, argv, &ret, &rtOpts)))
-		return ret;
+    /* Initialize run time options with command line arguments */
+    if (!(ptpClock = ptpdStartup(argc, argv, &ret, &rtOpts)))
+        return ret;
 
-	/* global variable for message(), please see comment on top of this file */
-	G_ptpClock = ptpClock;
+    /* global variable for message(), please see comment on top of this file */
+    G_ptpClock = ptpClock;
 
-	/* do the protocol engine */
-	protocol(&rtOpts, ptpClock);
-	/* forever loop.. */
+    /* do the protocol engine */
+    protocol(&rtOpts, ptpClock);
+    /* forever loop.. */
 
-	ptpdShutdown(ptpClock);
+    ptpdShutdown(ptpClock);
 
 	NOTIFY("self shutdown, probably due to an error\n");
 
-	return 1;
+    return 1;
 }
